# -*- coding: utf_8 -*-

from pandac.PandaModules import *

class gameLocation():
	#def __init__(self, model):
	def initTerrain(self):
			self.terrain=GeoMipTerrain("Terrain")
			#taskMgr.add(self.update,'location_update')

	def loadTerrain(self,hfFile):
			self.terrain.setHeightfield(Filename(hfFile))
			self.terrain.setBlockSize(32)
			self.terrain.setFactor(32)
			self.terrain.setMinLevel(2)
			self.terrain.getRoot().reparentTo(render)
			self.terrain.getRoot().setSz (20)
			self.terrain.generate()
			self.root = self.terrain.getRoot()
			#self.root.setSx(0.5)
			#self.root.setSy(0.5)
			#self.root.setSz(0.5)
			self.root.setPos(0,0,0)
			#print dir(self.root)
			self.root.flattenLight() 
			#self.root.flattenStrong() 
			gnodes = self.root.findAllMatches("+GeomNode")
			for gnode in gnodes:
				gnode.node().setIntoCollideMask(BitMask32.bit(5))
			
	def setTexture(self,texFile,sx,sy):
			self.terrain.getRoot().setTexture(loader.loadTexture(texFile))
			self.terrain.getRoot().setTexScale(TextureStage.getDefault(), sx, sy)
			self.terrain.getRoot().getTexture().setMinfilter(Texture.FTLinearMipmapLinear)
			
	def setLights(self,ambient_l,camera_l):
			self.ambientLight = render.attachNewNode( AmbientLight( "ambientLight" ))
			self.pointLight = camera.attachNewNode( PointLight( "PointLight" ) )
			self.ambientLight.node().setColor(ambient_l)
			self.pointLight.node().setColor(camera_l)
			render.setLight( self.ambientLight )
			render.setLight( self.pointLight )

	def update(self,task):
			self.terrain.update()
			#self.root.setRenderModeWireframe()
			#self.root.setRenderModeFilled()
			#self.root.setRenderModePerspective(45,45)
			#self.root.setRenderModeThickness(45,45)
			return task.cont 

