# -*- coding: utf_8 -*-

from pandac.PandaModules import *
from direct.task import Task
from math import pi
from modules.tank import gameTank

class gamePlayer(gameTank):

	def __init__(self, model= "res/actors/tank", pos = (2,2,0,0,0,0), nick = "default-player", mask = 0, speed = 2):
		gameTank.__init__(self, model, pos, nick, mask, speed)
		
		# ключи для управления через клаву
		self.keyMap = {	"norma":0,"left":0, "right":0, "forward":0, "back":0, 
								"bashnya-left":0, "bashnya-right":0, "cam-up":0,
								"cam-down":0, "fire":0, "cam-left":0, "cam-right":0}
								

		self.setUpCamera()
		self.attachControls()
		taskMgr.add(self.movePLAYER, 'move-task-PLAYER')

	def setUpCamera(self):
		# отключаем стандартное управление мышой
		base.disableMouse()
		# определяем водителя для камеры		
		#self.boxCam = render.attachNewNode('boxCam') 
		# устанавлеваем начальное положение камеры
		base.camera.setX(self.boxCam, 0)
		base.camera.setY(self.boxCam, -7)
		base.camera.setZ(1)
		base.camera.reparentTo(self.boxCam)
		base.camera.lookAt(self.boxCam)

	# обработчик нажатия клавиши
	def setKey(self, key, value):
		self.keyMap[key] = value
		
	def attachControls(self):
		# связываем клавиши с действиями
		base.accept("arrow_left", self.setKey, ["left",1])
		base.accept("arrow_right", self.setKey, ["right",1])
		base.accept("arrow_up", self.setKey, ["forward",1])
		base.accept("arrow_down", self.setKey, ["back",1])
		base.accept("a", self.setKey, ["bashnya-left",1])
		base.accept("s", self.setKey, ["bashnya-right",1])
		base.accept("q", self.setKey, ["cam-left",1])
		base.accept("w", self.setKey, ["cam-right",1])
		base.accept("space", self.setKey, ["fire",1])
		base.accept("space-up", self.setKey, ["fire",0])
		base.accept("n", self.setKey, ["norma",1])
		base.accept("n-up", self.setKey, ["norma",0])
		base.accept("page_up", self.setKey, ["cam-up",1])
		base.accept("page_up-up", self.setKey, ["cam-up",0])
		base.accept("page_down", self.setKey, ["cam-down",1])
		base.accept("page_down-up", self.setKey, ["cam-down",0])
		base.accept("arrow_left-up", self.setKey, ["left",0])
		base.accept("arrow_right-up", self.setKey, ["right",0])
		base.accept("arrow_up-up", self.setKey, ["forward",0])
		base.accept("arrow_down-up", self.setKey, ["back",0])
		base.accept("a-up", self.setKey, ["bashnya-left",0])
		base.accept("s-up", self.setKey, ["bashnya-right",0])
		base.accept("q-up", self.setKey, ["cam-left",0])
		base.accept("w-up", self.setKey, ["cam-right",0])
		
	def movePLAYER(self, task):
		elapsed = globalClock.getDt()
		
		# поворот камеры по горизонту
		if (self.keyMap["cam-left"]!=0):
			base.camera.setX(base.camera, +(elapsed*5.0))
		if (self.keyMap["cam-right"]!=0):
			base.camera.setX(base.camera, -(elapsed*5.0))
		
		# поворот камеры по вертикали
		if (self.keyMap["cam-up"]!=0):
			base.camera.setZ(base.camera, +(elapsed*5.0))
		if (self.keyMap["cam-down"]!=0):
			base.camera.setZ(base.camera, -(elapsed*5.0))
		
		# анимация выстрела
		if (self.keyMap["fire"]!=0):
			povorotS = self.stvol.getHpr()
			self.stvol.setHpr(0, 6, 0)
			self.keyMap["fire"]=0
		if (self.keyMap["fire"]==0):
			povorotS = self.stvol.getHpr()
			if povorotS[1]>0:
				self.stvol.setHpr(0, povorotS[1]-.5, 0)
		
		# поворот башни
		povorotB = self.bashnya.getHpr()
		if (self.keyMap["bashnya-left"]!=0):
			self.bashnya.setH(self.bashnya, +(elapsed*60.0))
		if (self.keyMap["bashnya-right"]!=0):
			self.bashnya.setH(self.bashnya, -(elapsed*60.0))
		
		# поворот танка
		if (self.keyMap["left"]!=0):
			self.angleTank = self.angleTank + elapsed*75.0
		if (self.keyMap["right"]!=0):
			self.angleTank = self.angleTank - elapsed*75.0
		
		# движение танка
		if (self.keyMap["forward"]!=0):
			self.node.setY(self.node, elapsed*self.speed)
		if (self.keyMap["back"]!=0):
			self.node.setY(self.node, -(elapsed*self.speed/2.0))
			
		# возврат в исходное состояние камеры? и башни
		if (self.keyMap["norma"]!=0):
			self.bashnya.setHpr(0, 0, 0)
		
		# двигаем boxCam за танком
		#self.boxCam.setPos(self.node.getPos())
		#self.boxCam.setZ(self.node, 1)
		#self.boxCam.setH(self.node.getH())
		base.camera.lookAt(self.boxCam)
		#выходим из обработчика
		return Task.cont